

def somme_magique(n):
    return n * (n ** 2 + 1) // 2

def taille(A): return len(A)

def matrice_vide(n):
    A = n * [None]
    for i in range(n):
        A[i] = n * [None]
    return A

def somme_ligne(A, i):
    n = taille(A)
    s = 0
    for j in range(n):
        s += A[i][j]
    return s

def somme_colonne(A, j):
    n = taille(A)
    s = 0
    for i in range(n):
        s += A[i][j]
    return s

def somme_diag1(A):
    n = taille(A)
    s = 0
    for i in range(n): s += A[i][i]
    return s

def somme_diag2(A):
    n = taille(A)
    s = 0
    for i in range(n): s += A[i][n - 1 - i]
    return s

def est_matrice_magique(A):
    s = somme_ligne(A, 0)
    n = taille(A)
    for i in range(n):
        if somme_ligne(A, i) != s: return False
        if somme_colonne(A, i) != s: return False
    if somme_diag1(A) != s: return False
    if somme_diag2(A) != s: return False
    return True

def est_normal(A):
    n = taille(A)
    s = [A[i][j] for i in range(n) for j in range(n)]
    s.sort()
    for k in range(n ** 2):
        if s[k] != k + 1: return False
    return True

def est_carre_magique_normal(C):
    return est_matrice_magique(C) and est_normal(C)

def print_carre(C):
    n = taille(C)
    for i in range(n):
        print('+' + n * '----+')
        print('|', end='')
        for j in range(n):
            
            print('%4d|' % C[i][j], end='')
        print()
    print('+' + n * '----+')
